/*
 * common.c: stubs to SHADOW FORTRAN NAMELIST data
 *
 * Author: Mumit Khan <khan@xraylith.wisc.edu>
 *
 * ------------------------------------------------
 *             SHADOW
 *    Center for X-ray Lithography
 *   University of Wisconsin-Madison
 * 3731 Schneider Dr., Stoughton, WI, 53589
 * ------------------------------------------------
 *
 */

#include "common.h"

/*
 * Now map each FORTRAN common block onto a C struct and off we go! These
 * already defined in SHADOW common block, so if we're not linking with
 * SHADOW library, define here; if linking with SHADOW library, leave
 * these alone.
 */

#if !USE_SHADOW_LIBRARY

struct XMATHBLK MATHBLK;
struct XFLAGS FLAGS;
struct XCALC CALC;
struct XSYSTEM1 SYSTEM1;
struct XMIRROR MIRROR;
struct XGRATING GRATING;
struct XXTAL XTAL;
struct XROT_MIR ROT_MIR;
struct XSLIT SLIT;
struct XSOURCE SOURCE;
struct XALADDIN ALADDIN;
struct XTRIG TRIG;
struct XIMAGE IMAGE;
struct XAXIS AXIS;
struct XRIPPLE RIPPLE;
struct XSEGMENT SEGMENT;
struct XFACET FACET;
struct XKOMA KOMA;
struct XNAMES NAMES; 
struct XRIPP_2 RIPP_2;
struct XLIGHT LIGHT;
struct XSCREENS SCREENS;
struct XHOLO HOLO;

#endif
